(function(exports) {
    var rehaAPI = {
    	//获取日历列表
		calendarPlanDetail: function(data) {
			return httpRequest.get("doctor/specialist/rehabilitation/calendarPlanDetail",{data:data})
		},
		//获取列表
		calendarPlanDetailList: function(data) {
			return httpRequest.get("doctor/specialist/rehabilitation/calendarPlanDetailList",{data:data})
		},
		serviceItemList:function(data){
			return httpRequest.get("doctor/specialist/rehabilitation/serviceItemList",{data:data})
		},
		serviceItem:function(data){
			return httpRequest.get("doctor/specialist/rehabilitation/serviceItem",{data:data})
		},
		//获取医生二维码
		createServiceQrCode: function(data){
			return httpRequest.post('doctor/specialist/rehabilitation/createServiceQrCode',{data:data})
		},
//		居民扫码后验证是否是关联的居民扫码(居民端)
		checkAfterQrCode: function(data){
			return httpRequest.post('patient/specialist/rehabilitation/checkAfterQrCode',{data:data})
		},
		upload:function(file){
			return httpRequest.post('upload/fastDFSImag',{data: file,contentType: false,
            cache: false,
            processData: false})
		},
		updateNoteAndImageRehabilitationOperate:function(data){
			return httpRequest.post('doctor/specialist/rehabilitation/updateNoteAndImageRehabilitationOperate',{data:data})
		},
//		新增operateRecodr
		saveRehabilitationOperateRecord:function(data){
			return httpRequest.post('doctor/specialist/rehabilitation/saveRehabilitationOperateRecord',{data:data})
		},
		// 服务项关联计划
		updateRelationCodeByDetailId:function(data){
			return httpRequest.post('doctor/specialist/rehabilitation/updateRelationCodeByDetailId',{data:data})
		},
		// 康复服务套餐管理-获取康复服务套餐模板列表
		findTemplateList:function(data){
			return httpRequest.get("doctor/specialist/rehabilitationPlan/findTemplateList",{data:data})
		},
		// 康复服务套餐管理-获取机构服务项目列表
		findServiceItemsByHospital:function(data){
			return httpRequest.get("doctor/specialist/hospitalServiceItem/findServiceItemsByHospital",{data:data})
		},
		//获取医生团队信息
		getDoctorTeam: function(uid){
			return httpRequest.get('doctor/admin-teams/team/'+uid+'/teams')
		},		
		createTemplate:function(data){
			return httpRequest.post('doctor/specialist/rehabilitationPlan/createTemplate',{data:data})
		},
		createTemplateDetail:function(data){
			return httpRequest.post('doctor/specialist/rehabilitationPlan/createTemplateDetail',{data:data})
		},
		findTemplateDetail:function(data){
			return httpRequest.get("doctor/specialist/rehabilitationPlan/findTemplateDetail",{data:data})
		},
		deleteTemplate:function(data){
			return httpRequest.post('doctor/specialist/rehabilitationPlan/deleteTemplate',{data:data})
		},
		selectByIds:function(data){
			return httpRequest.get("doctor/specialist/hospitalServiceItem/selectByIds",{data:data})
		},
		// 终止专科计划详情
		getServiceItemsAfterStop: function(data) {
			return httpRequest.get("doctor/specialist/rehabilitation/getServiceItemsAfterStop", {data: data})
		},
		//获取计划表
		planSchedule: function(data) {
			return httpRequest.get("doctor/specialist/rehabilitation/planSchedule", {data: data})
		},
		//获取服务医生列表
		serviceDoctorList: function(data) {
			return httpRequest.get("doctor/specialist/rehabilitation/serviceDoctorList", {data: data})
		},
		//发送模板信息给居民确认
		sendWxMsg: function(data) {
			return httpRequest.post("doctor/specialist/rehabilitationPlan/sendWxMsg", {data: data})
		},
		//获取康复计划服务项
		calendarPlanDetailItems: function(data) {
			return httpRequest.get("doctor/specialist/rehabilitation/calendarPlanDetailItems",{data:data})
		},
		//获取康复服务项
		getServiceItemList: function(data) {
			return httpRequest.get("doctor/specialist/rehabilitation/getServiceItemList", {data: data})
		},
		//获取下转居民列表
		getRehabilitationPatientList: function(data) {
			return httpRequest.get("/doctor/rehabilitation/getRehabilitationPatientList", {data: data})
		},
		//获取居民标签字典（健康情况、疾病类型、自定义分组）
		getSpecialistPatientLabel: function(data) {
			return httpRequest.get("doctor/patient_label/getSpecialistPatientLabel", {data: data})
		},
		//获取居民标签（健康情况、疾病类型、自定义分组）
		getPatientLabelInfo: function(data) {
			return httpRequest.get("doctor/patient_label_info/getPatientLabelInfo", {data: data})
		},
		// 获取诊断信息
		getIcd10Info: function(data) {
			return httpRequest.get("doctor/serviceOrder/getIcd10Info", {data: data})
		},
		// 添加住院病历
		createMedicalRecords: function(data) {
			return httpRequest.post("/doctor/rehabilitation/createMedicalRecords", {data: data})
		},
		// 获取住院病历列表
		selectByMedicalCode: function(data){
			return httpRequest.get("doctor/specialist/rehabilitation/selectByMedicalCode", {data: data})
		},
		// 获取康复计划列表
		selectPlanByPatient: function(data){
			return httpRequest.get("doctor/specialist/rehabilitation/selectPlanByPatient", {data: data})
		},
		// 获取康复计划列表
		selectPlanServerDoctor: function(data){
			return httpRequest.post("doctor/specialist/rehabilitation/selectPlanServerDoctor", {data: data})
		},
		// 获取专科团队
		getSpecialistTeamList: function(data){
			return httpRequest.get("doctor/specialist/getSpecialistTeamList", {data: data})
		},
		// 更新居民专科标签（健康情况、疾病类型、自定义分组）
		updatePatientLabelInfo: function(data){
			return httpRequest.get("doctor/patient_label_info/updatePatientLabelInfo", {data: data})
		},
		// 提醒患者
		sendSpecialistWeixinMessage: function(data){
			return httpRequest.get("doctor/specialist/rehabilitation/sendSpecialistWeixinMessage", {data: data})
		},
		// 十大病种列表
		selectType: function(data){
			return httpRequest.get("doctor/specialist/rehabilitation/selectType", {data: data})
		},
		// 康复指导列表
		selectGuidances: function(data){
			return httpRequest.get("doctor/specialist/rehabilitation/selectGuidances", {data: data})
		},
		// 发送康复指导
		sendGuidance: function(data){
			return httpRequest.get("doctor/specialist/rehabilitation/sendGuidance", {data: data})
		},
		// 获取团队二维码
		createSpecialDoctorQrCode: function(data){
			return httpRequest.post("doctor/specialist/rehabilitation/createSpecialDoctorQrCode", {data: data})
		},
		// 居民未与扫描的二维码团队对应
		createPatientInSpeciaRelation: function(data){
			return httpRequest.post("doctor/specialist/createPatientInSpeciaRelation", {data: data})
		},
		// 获取居民签约的专科团队
		findPatientTeamList: function(data){
			return httpRequest.get("doctor/specialist/findPatientTeamList", {data: data})
		},
		// 获取不限频次的服务项记录
		selectByPlanDetaiId: function(data){
			return httpRequest.get("doctor/specialist/rehabilitation/selectByPlanDetaiId", {data: data})
		},
		// 根据患者身份证或社保卡号进行搜索添加出院记录
		getPatientByIdcardOrSsc: function(data){
			return httpRequest.post("doctor/rehabilitation/getPatientByIdcardOrSsc", {data: data})
		},
		// 获取康复计划服务项的指导留言
		selectByGuidance: function(data){
			return httpRequest.get("doctor/specialist/rehabilitation/selectByGuidance", {data: data})
		},
		// 远程协诊
		appointmentConsultation: function(data){
			return httpRequest.get("doctor/specialist/rehabilitation/appointmentConsultation", {data: data})
		},
	}
    exports.rehaAPI = rehaAPI;
})(window)