(function(exports) {
    var statisticAPI = {
        /*************首页*******************/
        getSignInfo: function(data){
            return httpRequest.get("/statistics/sign_info", {data: data});
        },
        /*************总体分析页面接口列表**************/
        //1、顶部各个tab的值
        statisticTotal: function(data){
            return httpRequest.get("/statistics/total", {data: data});
        },
        //微信绑定和设备绑定数据接口
        statisticBindAll: function(data){
            return httpRequest.get("/statistics/index_all", {data: data});
        },
        //健康文章发送数量
        articleAll: function(data){
            return httpRequest.get("/statistics/article_total", {data: data});
        },
        //2、中间折线图接口 
        //增量（咨询量3、随访量4、健康教育5、代预约量27），到达量（绑定微信21、绑定设备20）
        interval: function(data){
            return httpRequest.get("statistics/interval", {data: data});
        },
        intervalTotal: function(data){
            return httpRequest.get("statistics/interval_total", {data: data});
        },
        //3、底部区域数据接口
        lowlevelTotal: function(data){
            return httpRequest.get("statistics/lowlevel_total", {data: data});
        },
        //微信绑定和设备绑定
        lowlevelAll: function(data){
            return httpRequest.get("statistics/lowlevel_all", {data: data});
        },
        //咨询量数据
        lowlevelTotalMesh: function(data){
            return httpRequest.get("statistics/lowlevel_total_mesh", {data: data});
        },
        articleLowlevelTotal: function(data){
            return httpRequest.get("/statistics/article_lowlevel_total", {data: data});
        },
        lowlevelData: function(url, data){
            return httpRequest.get(url, {data: data});
        },
        //获得团队的详情
        getTeamInfo: function(data){
            return httpRequest.get("doctor/admin-teams/teams/info", {data: data});
        },
        //获取居民分析相关数据
        leveltwoIncrementData: function(data){
            return httpRequest.get("/statistics/leveltwo_increment", {data: data});
        },
        statisticsTime:function(data){
        	return httpRequest.get("/statistics/time", {data: data});
        },
        //长处方分析接口
        getPrescriptionTotalHistogram: function(data){
            return httpRequest.get("statistics/getPrescriptionTotalHistogram", {data: data})
        },
        //评价分析
        //按月份获得个月的评价平均分
        getAVGSocreByMonth: function(data){
            return httpRequest.get("/statistics/getAVGSocreByMonth", {data: data});
        },
        //资质分析
        doorQualificationAnalyze: function(data){
            return httpRequest.get("/doctor/statisticAnalyze/doorQualificationAnalyze", {data: data});
        },
        //资质分析导出excel
        doorQualificationAnalyzeExport:httpRequest.server+"doctor/statisticAnalyze/doorQualificationAnalyzeExport",
        //响应速度分析
        doorResponseAnalyze: function(data){
            return httpRequest.get("/doctor/statisticAnalyze/doorResponseAnalyze", {data: data});
        },
        //响应速度分析导出excel
        doorResponseAnalyzeExport:httpRequest.server+"doctor/statisticAnalyze/doorResponseAnalyzeExport",
        //服务工单分析
        doorServiceOrderAnalyze: function(data){
            return httpRequest.get("/doctor/statisticAnalyze/doorServiceOrderAnalyze", {data: data});
        },
        //服务工单分析导出excel
        doorServiceOrderAnalyzeExport:httpRequest.server+"doctor/statisticAnalyze/doorServiceOrderAnalyzeExport",
        //补助费用
        subsidyExpense: function(data){
            return httpRequest.get("/doctor/statisticAnalyze/subsidyExpense", {data: data});
        },
        //补助费用导出excel
        subsidyExpenseExport:httpRequest.server+"doctor/statisticAnalyze/subsidyExpenseExport",
        
        //代预约记录
        GetReservationByTeamId: function(data){
            return httpRequest.post("/doctor/guahao/GetReservationByTeamId", {data: data});
        },
        
        //数据导出查询
        getStatisticDataList: function(data){
            return httpRequest.get("statisticsExport/getStatisticDataList", {data: data});
        },
        //数据导出查询-左侧树
        exportTreeList: function(data){
            return httpRequest.get("statisticsExport/treeList", {data: data});
        },
        // 专病分析-疾病类型
        specialistAnalysisDiseaseType: function(data){
            return httpRequest.get("specialistStatistics/specialistAnalysisDiseaseType", {data: data});
        },
        selectHospital: function(data){
            return httpRequest.get("specialistStatistics/selectHospital", {data: data});
        },
		//数据导出查询
		getWHFInfoList: function(data){
		    return httpRequest.get("third/door/getWHFInfoList", {data: data});
		},
		
		// 咨询分析明细  
		getConsultList: function(data){
		    return httpRequest.get("statisticsExport/getConsultList", {data: data});
		},
			
		// 签约分析明细
		getSignList: function(data){
		    return httpRequest.get("statisticsExport/getSignList", {data: data});
		},
		// 专病分析明细
		getSickList: function(data){
		    return httpRequest.get("statisticsExport/getSickList", {data: data});
		},
		
		// 生日祝福分析明细
		getBirthdayPatientList: function(data){
		    return httpRequest.get("statisticsExport/getBirthdayPatientList", {data: data});
		},
		//导出生日祝福分析明细
		getBirthdayPatientListExport: function(data){
		    return httpRequest.get("statisticsExport/getBirthdayPatientListExport", {data: data});
		},
		
		// 上门服务分析明细
		getDoorServiceList: function(data){
		    return httpRequest.get("statisticsExport/getDoorServiceList", {data: data});
		},
		
		// 长处方分析明细
		getPrescriptionList: function(data){
		    return httpRequest.get("statisticsExport/getPrescriptionList", {data: data});
		},
		
		// 获取专病疾病类型
		getDiseaseTypeList: function(data){
		    return httpRequest.get("statisticsExport/getDiseaseTypeList", {data: data});
		},
		// 年度考核报表
		getAnnualAssessment: function(data){
		    return httpRequest.get("statisticsExport/getAnnualAssessment", {data: data});
		},
		// 体征数据列表
		getHealthList: function(data){
		    return httpRequest.get("statisticsExport/getHealthList", {data: data});
		},
		// 上转预约列表
		getDoctorReservationList: function(data){
		    return httpRequest.get("statisticsExport/getDoctorReservationList", {data: data});
		},
		// 专病复诊明细列表
		getXxzxMedicalHistoryList: function(data){
		    return httpRequest.get("statisticsExport/getXxzxMedicalHistoryList", {data: data});
		},
		// 微信绑定列表
		getWexinBindingList: function(data){
		    return httpRequest.get("statisticsExport/getWexinBindingList", {data: data});
		},
		// 查询上转预约科室和医院
		getReservationHosAndDept: function(data){
		    return httpRequest.get("statisticsExport/getReservationHosAndDept", {data: data});
		},
		//  获取汇总数据的专科医院
		getSpecialHospital: function(data){
		    return httpRequest.get("statisticsExport/getSpecialHospital", {data: data});
		},
		//专病汇总查询
		getSpecialDiseaseReport: function(data){
		    return httpRequest.get("statisticsExport/getSpecialDiseaseReport", {data: data});
		},
		//体征分析查询
		getDeviceHealthReport: function(data){
		    return httpRequest.get("statisticsExport/getDeviceHealthReport", {data: data});
		},
		//上门汇总
		getDoorServerOrderReport: function(data){
		    return httpRequest.get("statisticsExport/getDoorServerOrderReport", {data: data});
		},
		// 居民积分明细
		patinetIntegralAnalysis: function(data){
		    return httpRequest.get("statisticsExport/patinetIntegralAnalysis", {data: data});
		},
		// 入户访视明细
		findPatientFollowListByCondition: function(data){
		    return httpRequest.get("statisticsExport/findPatientFollowListByCondition", {data: data});
		},
		//康复下转明细
		rehabilitationPatientInfo: function(data){
		    return httpRequest.get("doctor/specialist/rehabilitation/rehabilitationPatientInfo", {data: data});
		},
		// 康复下转分配，同步居民，同步病历
		synchronizePationSingle: function(data){
		    return httpRequest.post("doctor/specialist/rehabilitation/synchronizePationSingle", {data: data});
		},
		//康复下转获取签约信息
		kangfuGetSignInfo: function(data){
		    return httpRequest.get("doctor/specialist/rehabilitation/getSignInfo", {data: data});
		},
		// 获取社区医院
		hospitalsByType: function(data){
		    return httpRequest.get("hospitals/hospitalsByType", {data: data});
		},
		// 邀请专科医生回复明细列表
		consultHelpDetailPage: function(data){
		    return httpRequest.get("statisticsExport/consultHelpDetailPage", {data: data});
		},
		// 邀请专科医生回复统计列表
		consultHelpCountPage: function(data){
		    return httpRequest.get("statisticsExport/consultHelpCountPage", {data: data});
		},
		
		// 获取慢阻肺医院工作量表
		hospitalWorkStatistics: function(data){
		    return httpRequest.get("copd/statistics/hospitalWorkStatistics", {data: data});
		},
		
		// 级联查询医院
		cascadingFindHosptail: function(data){
		    return httpRequest.get("copd/statistics/cascadingFindHosptail", {data: data});
		},

		// 获取慢阻肺V1\入组情况报表
		findHospitalEntryCount: function(data){
		    return httpRequest.get("copd/statistics/findHospitalEntryCount", {data: data}); 
		},

		//慢阻肺患者查询
		getCopdPatientInfoList: function(data){
			return httpRequest.get("copd/statistics/getCopdPatientInfoList", {data: data}); 
		},

		//慢阻肺入组进度表
		getCopdEntryData: function(data){
		    return httpRequest.get("copd/statistics/getCopdEntryData", {data: data}); 
		},
		
		//慢阻肺入组明细
		getCopdEntryCommunityData: function(data){
		    return httpRequest.get("copd/statistics/getCopdEntryCommunityData", {data: data}); 
		},

		
		//慢阻肺随访进度表
		getCopdFollowData: function(data){
			return httpRequest.get("copd/statistics/getCopdFollowData", {data: data}); 
		},

		//慢阻肺随访明细表-PC
		getCopdFollowDetailData: function(data){
			return httpRequest.get("copd/statistics/getCopdFollowDetailData", {data: data}); 
		},

		//阻肺呼吸训练数据【获取慢阻肺的呼吸的列表数据】
		findCopdHealthInfoList: function(data){
			return httpRequest.get("copd/statistics/findCopdHealthInfoList", {data: data}); 
		},

		// 一个患者所有的呼吸数据
		findCopdHealthInfoByCode: function(data){
			return httpRequest.get("copd/statistics/findCopdHealthInfoByCode", {data: data}); 
		},

		// 获取个案的随访信息【随访计划】
		findCopdPatientFollowList: function(data){
			return httpRequest.get("copd/statistics/findCopdPatientFollowList", {data: data}); 
		},
		// 获取慢阻肺手表数据
		watchStatisticsList: function(data){
			return httpRequest.get("copd/statistics/watchStatisticsList", {data: data}); 
		},
		// 获取慢阻肺手表亚组居民列表
		watchPage: function(data){
			return httpRequest.get("copd/statistics/watchPage", {data: data}); 
		},
		// 获取慢阻肺手表体征数据明细
		copdList: function(data){
			return httpRequest.get("doctor/health_index/copdList", {data: data}); 
		},
		// 慢阻肺监查、稽查情况统计查询
		getCopdCheckExamineData: function(data){
			return httpRequest.get("copd/statistics/getCopdCheckExamineData", {data: data}); 
		},
		// 慢阻肺第二阶段三级医院入组进度
		getGradeHospitalEntryData: function(data){
			return httpRequest.get("/copd/statistics/getGradeHospitalEntryData", {data: data}); 
		},
	    // 慢阻肺第二阶段社区医院入组进度
	    getCommunityHospitalEntryData: function(data){
	    	return httpRequest.get("/copd/statistics/getCommunityHospitalEntryData", {data: data}); 
	    },
		// 慢阻肺第二阶段三级医院随访进度
		getGradeHospitalFollowData: function(data){
			return httpRequest.get("/copd/statistics/getGradeHospitalFollowData", {data: data}); 
		},
		// 慢阻肺第二阶段社区医院随访进度
		getCommunityHospitalFollowData: function(data){
			return httpRequest.get("/copd/statistics/getCommunityHospitalFollowData", {data: data}); 
		},
		// 慢阻肺第一阶段入组随访进度
		getFirstStageEntryData: function(data){
			return httpRequest.get("/copd/statistics/getFirstStageEntryData", {data: data}); 
		},
		// 慢阻肺第二阶段三级医院随访进度及出组情况
		getFollowAndOutData: function(data){
			return httpRequest.get("/copd/statistics/getFollowAndOutData", {data: data}); 
		},
		
        		
		
		
		
		
		
		
		
		
		

		// 综合分析导出
		statisticsExportExport: function(data, filename){
		    return httpRequest.downLoadFileForAjax("statisticsExport/export", filename, data);
		},
		// 咨询分析导出
		statisticsExportExportConsultList: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportConsultList", filename, data);
		},
		// 签约分析导出
		statisticsExportExportSignList: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportSignList", filename, data);
		},
		// 专病分析导出
		statisticsExportExportSickList: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportSickList", filename, data);
		},
		// 生日祝福分析导出
		statisticsExportGetBirthdayPatientListExport: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/getBirthdayPatientListExport", filename, data);
		},
		// 上门服务导出
		statisticsExportExportDoorServiceList: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportDoorServiceList", filename, data);
		},
		// 长处方导出
		statisticsExportExportPrescriptionList: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportPrescriptionList", filename, data);
		},
		// 年度考核报表导出
		statisticsExportExportAnnualAssessment: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportAnnualAssessment", filename, data);
		},
		// 咨询未及时回复导出
		appAdminToExcel: function(data, filename){
			return httpRequest.downLoadFileForAjax("third/door/appAdminToExcel", filename, data);
		},
		//体征数据导出
		exportHealthList: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportHealthList", filename, data);
		},
		//上转预约导出
		exportDoctorReservationList: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportDoctorReservationList", filename, data);
		},
		//微信绑定导出
		exportWexinBindingList: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportWexinBindingList", filename, data);
		},
		// 专病汇总导出
		exportSpecialDiseaseReport: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportSpecialDiseaseReport", filename, data);
		},
		// 体征分析导出
		exportDeviceHealthReport: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportDeviceHealthReport", filename, data);
		},
		// 上门汇总导出
		exportDoorServerOrderReport: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportDoorServerOrderReport", filename, data);
		},
		// 居民积分明细导出
		exPatinetIntegralAnalysis: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exPatinetIntegralAnalysis", filename, data);
		},
		// 入户访视明细导出
		exfindPatientFollowListByCondition: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exfindPatientFollowListByCondition", filename, data);
		},
		// 康复下转明细导出
		exportRehabilitationPatientInfo: function(data, filename){
			return httpRequest.downLoadFileForAjax("doctor/specialist/rehabilitation/exportRehabilitationPatientInfo", filename, data);
		},
		// 邀请专科医生回复明细导出
		exportConsultHelpDetailPage: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportConsultHelpDetailPage", filename, data);
		},
		// 邀请专科医生回复统计导出
		exportConsultHelpCountPage: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportConsultHelpCountPage", filename, data);
		},
		// 	慢阻肺医院工作量表导出
		exportHospitalWorkStatistics: function(data, filename){
			return httpRequest.downLoadFileForAjax("copd/statistics/exportHospitalWorkStatistics", filename, data);
		},
		
		// v1入组导出
		exportHospitalEntryCount: function(data, filename){
			return httpRequest.downLoadFileForAjax("copd/statistics/exportHospitalEntryCount", filename, data);
		},
		// 	专病复诊明细表导出
		exportXxzxMedicalHistoryList: function(data, filename){
			return httpRequest.downLoadFileForAjax("statisticsExport/exportXxzxMedicalHistoryList", filename, data);
		},
		
		// 慢阻肺入组进度表-PC-导出
		exportCopdEntryData: function(data, filename){
			return httpRequest.downLoadFileForAjax("copd/statistics/exportCopdEntryData", filename, data);
		},

		// 慢阻肺入组明细表-PC-导出
		exportCopdEntryCommunityData: function(data, filename){
			return httpRequest.downLoadFileForAjax("copd/statistics/exportCopdEntryCommunityData", filename, data);
		},

		//慢阻肺随访进度表-PC-导出
		exportCopdFollowData: function(data, filename){
			return httpRequest.downLoadFileForAjax("copd/statistics/exportCopdFollowData", filename, data);
		},

		//慢阻肺随访明细表-PC-导出
		exportCopdFollowDetailData: function(data, filename){
			return httpRequest.downLoadFileForAjax("copd/statistics/exportCopdFollowDetailData", filename, data);
		},

		// 呼吸数据导出
		exoprtCopdHealthInfoList: function(data, filename){
			return httpRequest.downLoadFileForAjax("copd/statistics/exoprtCopdHealthInfoList", filename, data);
		},

		 // 慢阻肺患者查询导出
		 exportCopdPatientInfoList: function(data, filename){
			return httpRequest.downLoadFileForAjax("copd/statistics/exportCopdPatientInfoList", filename, data);
		},
		
		//导出随访计划
		exportConclusionList: function(data, filename){
			return httpRequest.downLoadFileForAjax("doctor/copd/exportConclusionList", filename, data);
		},
		// 手表亚组数据导出
		exportWatchStatisticsList: function(data, filename){
			return httpRequest.downLoadFileForAjax("copd/statistics/exportWatchStatisticsList", filename, data);
		},
		// 手表亚组居民数据导出
		exportWatchPage: function(data, filename){
			return httpRequest.downLoadFileForAjax("copd/statistics/exportWatchPage", filename, data);
		},
		// 慢阻肺监查、稽查情况统计导出
		exportCopdCheckExamineData: function(data, filename){
			return httpRequest.downLoadFileForAjax("copd/statistics/exportCopdCheckExamineData", filename, data);
		},
		// 慢阻肺第一阶段入组随访情况统计导出
		exportFirstStageEntryData: function(data, filename){
			return httpRequest.downLoadFileForAjax("/copd/statistics/exportFirstStageEntryData", filename, data);
		},
		// 慢阻肺第二阶段社区医院随访情况导出
		exportCommunityHospitalFollowData: function(data, filename){
			return httpRequest.downLoadFileForAjax("/copd/statistics/exportCommunityHospitalFollowData", filename, data);
		},
		// 慢阻肺第二阶段三级医院随访情况统计导出
		exportGradeHospitalFollowData: function(data, filename){
			return httpRequest.downLoadFileForAjax("/copd/statistics/exportGradeHospitalFollowData", filename, data);
		},
		// 慢阻肺第二阶段社区医院入组情况统计导出
		exportCommunityHospitalEntryData: function(data, filename){
			return httpRequest.downLoadFileForAjax("/copd/statistics/exportCommunityHospitalEntryData", filename, data);
		},
		// 慢阻肺第二阶段三级医院入组情况统计导出
		exportGradeHospitalEntryData: function(data, filename){
			return httpRequest.downLoadFileForAjax("/copd/statistics/exportGradeHospitalEntryData", filename, data);
		},
		// 慢阻肺第二阶段三级医院随访进度及出组情况导出
		exportFollowAndOutData: function(data, filename){
			return httpRequest.downLoadFileForAjax("/copd/statistics/exportFollowAndOutData", filename, data);
		},
		
		
		
		
    }

    exports.statisticAPI = statisticAPI;
})(window)