function showSuccessMessage(msg) {
  layer.msg(msg, {
    icon: 1
  })
}

function showErrorMessage(msg) {
  layer.msg(msg, {
    icon: 5
  })
}

function showWarningMessage(msg) {
  layer.msg(msg, {
    icon: 2
  })
}

function showInfoMessage(msg) {
  layer.msg(msg, {
    icon: 6
  })
}


new Vue({
  el: '#app',
  data: {
    modal: '',
    type: '',
    status: '',
    name: '',
    isDanger: '1',
    pagesize: 10,
    total: 0,
    pagetotal: 0, //总页数
    currentPage: 1, //当前页数
    tablelist: [],
    types: [],
    Statics: {},
    wujilu: false,
    datamodelshow: true,
    centerDialogVisible: false,
	surveyResultCode:"",
	isloading:false,
	docInfo:JSON.parse(window.localStorage.getItem('docInfo')),
	jiayiShow:false,
	doctorMobile:'',
  },
  created:function() {
	
  },
  mounted: function () {
    var vm = this
    vm.getModal()
	// 专科
	if(vm.docInfo.level == '1') {
		vm.getList()
	}else{
		vm.getDatas()
	}
    vm.gettypes()
	parent.eventBuss.$on('guan_results',function(index){
		top.layer.close(index)
		if(vm.docInfo.level == '1') {
			vm.getList()
		}else{
			vm.getDatas()
		}
		vm.getModal()
	})
  },
  methods: {
	lianxijiayi:function(data) {
		this.doctorMobile = data.doctorMobile
		this.jiayiShow = true
	},
	centerDialogClick:function() {
		var vm = this
		var docInfo=JSON.parse(window.localStorage.getItem('docInfo'));
		this.centerDialogVisible = false
		vm.isloading = true
		jbscAPI.changeSurveyState({
			surveyResultCode:this.surveyResultCode,   //问卷code
			surveyStatus:1,       //surveyStatus =1 社区随访--已管理    
			doctorCode:docInfo.code        //医生code
		}).then(function(res){
			if(res.status == 200) {
				showSuccessMessage('操作成功')
				vm.isloading = false
				if(vm.docInfo.level == '1') {
					vm.getList()
				}else{
					vm.getDatas()
				}
				vm.getModal()
			}
		})
	},
    //获取筛查数据模型
    getModal: function () {
      var vm = this
      jbscAPI.screenStatics({
		  type:vm.docInfo.level==1?"2":'1' //  类型 1全科 2专科（默认1）
	  }).then(function (res) {
        if (res.status == 200) {
          vm.Statics = res.data
        } else {
          showErrorMessage(res.msg)
        }
      })
    },
    //获取数据
    getDatas: function () {
      var vm = this
      var params = {
        diseaseType: vm.type, //疾病类型
        dealType: vm.status, //处理方式(全部为空 1已预约 2已跟踪 3已接诊4待处理)
        patientName: vm.name, //搜索居民的姓名
        isDanger: vm.isDanger, //是否高危预警(0否 1是)
        pageNo: vm.currentPage,
        pageSize: vm.pagesize
      }
      jbscAPI.getResultList(params).then(function (res) {
        if (res.status == 200) {
          vm.wujilu = false
          vm.total = res.data.num
          vm.pagetotal = Math.ceil(res.data.num / vm.pagesize)
          vm.tablelist = res.data.data
          if (vm.tablelist.length == 0) {
            vm.wujilu = true
          }
        } else {
          showErrorMessage(res.msg)
        }
      })
    },
	getList:function() {
		var vm = this
		var params = {
			doctor: vm.docInfo.code, //专科医生code
            diseaseType: vm.type, //疾病类型
            type: vm.status, //处理方式(全部为空 1已预约 2已跟踪 3已接诊4待处理)
            patientName: vm.name, //搜索居民的姓名
            isDanger: vm.isDanger, //是否高危预警(''否 1是 0日常健康管理)
            pageNo: vm.currentPage,
            pageSize: vm.pagesize
		}
		jbscAPI.getList(params).then(function (res) {
		  if (res.status == 200) {
		    vm.wujilu = false
		    vm.total = res.total?res.total:'0'
		    vm.pagetotal = Math.ceil(res.total / vm.pagesize)
		    vm.tablelist = res.data
		    if (vm.tablelist.length == 0) {
		      vm.wujilu = true
		    }
		  } else {
		    showErrorMessage(res.msg)
		  }
		})
	},
    gettypes: function () {
      var vm = this
      var search = true
      $('#Status').bsSuggest({
        data: {
          value: [
            {
              code: '',
              name: '全部'
            },
            {
              code: '1',
              name: '已预约'
            },
            {
              code: '2',
              name: '已跟踪'
            },
            {
              code: '3',
              name: '已接诊'
            },
            {
              code: '4',
              name: '待处理'
            },
            {
              code: '5',
              name: '日常健康管理'
            },
            {
              code: '6',
              name: '已管理'
            },
            {
              code: '7',
              name: '住院补筛'
            }
          ]
        },
        getDataMethod: 'data',
        effectiveFields: ['name'],
        idField: 'code',
        keyField: 'name'
      })
      jbscAPI.getSpecialDisease().then(function (res) {
        if (res.status == 200) {
          var data = {}
          data.value = _.map(res.data, function (v) {
            return {
              code: v.code,
              name: v.name
            }
          })
          if (search) {
            data.value = [
              {
                code: '',
                name: '全部'
              }
            ].concat(data.value)
          }
          $('#Type').bsSuggest({
            data: data,
            getDataMethod: 'data',
            effectiveFields: ['name'],
            idField: 'code',
            keyField: 'name'
          })
          vm.types = res.data
        } else {
          showErrorMessage(res.msg)
        }
      })
    },
    gettable: function (type) {
      var vm = this
      if (type == '1') {
        if (vm.status == '') {
          $('#Status').attr({
            'data-id': '',
            'value': '全部'
          })
          $('#Status').val('全部')
        }
      } else {
        if (vm.status != '') {
          vm.status = ''
          $('#Status').attr({
            'data-id': '',
            'value': '全部'
          })
          $('#Status').val('全部')
        }
      }
      vm.isDanger = type
      vm.search(1)
    },
    //页面跳转
    search: function (page) {
      var vm = this
      vm.type = $('#Type').attr('data-id')
      var status = $('#Status').attr('data-id')
      if (status == '5') {
        vm.status = ''
        vm.isDanger = '0'
      } else if (status == '' || status == undefined) {
        if (vm.isDanger == '0') {
          vm.isDanger = ''
        }
        vm.status = status
      } else {
        vm.isDanger = '1'
        vm.status = status
      }
      vm.currentPage = page
	  if(vm.docInfo.level == '1') {
	  	vm.getList()
	  }else{
	  	vm.getDatas()
	  }
    },
    //转诊
    zhuanzhen: function (data) {
      // showInfoMessage('PC上暂不支持，请打开手机端疑似高危记录进行转诊预约!')
      // top.layer.msg('PC上暂不支持，请打开手机端疑似高危记录进行转诊预约', { icon: 5 })
      top.layer.open({
        type: 2,
        closeBtn: 1, // 显示关闭按钮
        area: ['800px', '90%'],
        title: '预约挂号',
        content: '../../jbsc/html/appointment/appoint-select.html?patient=' + data.patientCode + '&callCode='
      })
    },
    //健康教育
    jkjy: function (data) {
      //			sessionStorage.setItem("jbsc-jkwzreceiver", JSON.stringify(receiver))
      //			sessionStorage.setItem("jbsc-jkroler", 1)
      layer.open({
        type: 2,
        //				  offset: ['100px'], //右下角弹出
        area: ['80%', '648px'],
        shade: 0.5,
        title: '健康教育',
        fixed: true, //不固定
        maxmin: true,
        closeBtn: 1,
        shift: 5,
        shadeClose: false, //点击遮罩关闭层
        content: '../../article/html/article.html?code=' + data.patientCode + '&resultCode=' + data.code
      })
      //		location.href="../../../../health-education/login.html?origin=jbsc"
    },
    //健康指导
    jkzd: function (data) {
      //			sessionStorage.setItem("jbsc-jkwzreceiver", JSON.stringify(receiver))
      //			sessionStorage.setItem("jbsc-jkroler", 1)
      layer.open({
        type: 2,
        //				  offset: ['100px'], //右下角弹出
        area: ['80%', '648px'],
        shade: 0.5,
        title: '健康指导',
        fixed: true, //不固定
        maxmin: true,
        closeBtn: 1,
        shift: 5,
        shadeClose: false, //点击遮罩关闭层
        content: '../../guidance/html/index.html?patient=' + data.patientCode + '&resultCode=' + data.code
      })
      //		location.href="../../../../health-education/login.html?origin=jbsc"
    },
    view: function (data) {
		var vm = this
      layer.open({
        type: 2,
        //				  offset: ['100px'], //右下角弹出
        area: ['568px', '100%'],
        shade: 0.5,
        title: '查看筛选结果',
        fixed: true, //不固定
        maxmin: true,
        closeBtn: 1,
        shift: 5,
        shadeClose: false, //点击遮罩关闭层
        content: '../../jbsc/html/view_screening_results.html?isView=true&resultCode=' + data.code,
		end:function() {
			vm.tablelist = []
			if(vm.docInfo.level == '1') {
				vm.getList()
			}else{
				vm.getDatas()
			}
			vm.getModal()
		},
      })
    },
    //筛查
    shaicha: function (data, isNew) {
      var vm = this
      if (isNew) {
        //再次筛查数+1
        layer.open({
          type: 2,
          area: ['820px', '648px'],
          shade: 0.5,
          id: 'questionnaire',
          title: '筛选统计',
          fixed: true, //不固定
          maxmin: true,
          closeBtn: 1,
          shift: 5,
          shadeClose: false, //点击遮罩关闭层
          content:
            '../../jbsc/html/questionnaire.html?fliter_code=' +
            data.templateCode +
            '&fliter_title=' +
            data.templateTitle +
            '&resident_code=' +
            data.patientCode +
            '&resident_name=' +
            data.patientName
        })
        return
      }
      layer.open({
        type: 2,
        offset: 'rb', //右下角弹出
        id: 'filter_type',
        area: ['280px', '100%'],
        shade: 0.5,
        title: false,
        fixed: true, //不固定
        maxmin: false,
        closeBtn: 0,
        shift: 5,
        shadeClose: true, //点击遮罩关闭层
        content: '../../jbsc/html/filter_type.html'
      })
    },
    //健康跟踪
    jkgz: function (data) {
      var vm = this
      //跳转到筛查结果页面
      var index = layer.open({
        type: 2,
        area: ['500px', '550px'],
        shade: 0.5,
        title: '家医建议',
        fixed: true, //不固定
        maxmin: false,
        closeBtn: 1,
        shift: 5,
        shadeClose: false, //点击遮罩关闭层
        content: '../../jbsc/html/advice.html?resultCode=' + data.code + '&filter_code=' + data.templateCode
      })
      console.log(index)
    },
    datamodeltap: function () {
      var vm = this
      $('#sc_datamodel').toggle('normal', function () {
        if (vm.datamodelshow) {
          vm.datamodelshow = false
          $('#datamodeltap').removeClass('up_datamodel').addClass('down_datamodel')
          $('#datamodeltap span').text('展开')
        } else {
          vm.datamodelshow = true
          $('#datamodeltap').removeClass('down_datamodel').addClass('up_datamodel')
          $('#datamodeltap span').text('收起')
        }
      })
    },
    sqsf: function (item) {
      var vm = this
	  vm.surveyResultCode = item.code
      vm.centerDialogVisible = true
    }
  }
})
