Date.prototype.format = function (formatStr) {
  var str = formatStr
  var Week = ['日', '一', '二', '三', '四', '五', '六']

  str = str.replace(/yyyy|YYYY/, this.getFullYear())
  str = str.replace(
    /yy|YY/,
    this.getYear() % 100 > 9 ? (this.getYear() % 100).toString() : '0' + (this.getYear() % 100)
  )

  str = str.replace(/MM/, this.getMonth() > 8 ? (this.getMonth() + 1).toString() : '0' + (this.getMonth() + 1))
  str = str.replace(/M/g, this.getMonth() + 1)

  str = str.replace(/w|W/g, Week[this.getDay()])

  str = str.replace(/dd|DD/, this.getDate() > 9 ? this.getDate().toString() : '0' + this.getDate())
  str = str.replace(/d|D/g, this.getDate())

  str = str.replace(/hh|HH/, this.getHours() > 9 ? this.getHours().toString() : '0' + this.getHours())
  str = str.replace(/h|H/g, this.getHours())
  str = str.replace(/mm/, this.getMinutes() > 9 ? this.getMinutes().toString() : '0' + this.getMinutes())
  str = str.replace(/m/g, this.getMinutes())

  str = str.replace(/ss|SS/, this.getSeconds() > 9 ? this.getSeconds().toString() : '0' + this.getSeconds())
  str = str.replace(/s|S/g, this.getSeconds())

  return str
}

function isMobilePhone(n) {
  var reg = /^1[3|4|5|6|7|8|9][0-9]{9}$/
  return reg.test(n)
}

function isTelPhone(n) {
  var reg = /^(\(\d{3,4}\)|\d{3,4}-|\s)?\d{7,14}$/
  return reg.test(n)
}

function getDateFromNow(days) {
  if (!days) {
    return new Date().format('yyyy-MM-dd')
  }
  var now = new Date().getTime()
  var diff = 24 * 3600 * 1000 * days
  return new Date(now + diff).format('yyyy-MM-dd')
}

function GetRequest() {
  var url = location.search //获取url中"?"符后的字串
  var theRequest = new Object()
  if (url.indexOf('?') != -1) {
    var str = url.substr(1)
    strs = str.split('&')
    for (var i = 0; i < strs.length; i++) {
      theRequest[strs[i].split('=')[0]] = strs[i].split('=')[1]
    }
  }

  return theRequest
}
function getWeek(d) {
  var dateArray = d.split('/')
  var year = dateArray[0],
    month = dateArray[1],
    date = dateArray[2]
  var dt = new Date(year, month - 1, date)
  var weekDay = ['周天', '周一', '周二', '周三', '周四', '周五', '周六']
  return weekDay[dt.getDay()]
}
